; This function uses exofast_occultquad (Mandel & Algol 2008) 
; to find a model fit with the input parameters  
; To be used in EXOMOP.pro but can be used separately. 
; INPUT: 
;        time (HJD) 
;        input_parameters (Rp/R*,a/R*,I,mid,lin,quad,period)
;OUPUT:  flux_model (model fit of input_parameters)
;MODIFICATION HISTORY
;
; 2/13/13 --- Jake Turner (LPL) 2013 
; 		program created


function model_fit,time,fit_start
pi =!PI


rp 		= fit_start[0] 
a_rstar		= fit_start[1] 
incl 		= fit_start[2]
mid_transit 	= fit_start[3] 
linlimb 	= fit_start[4]
quadlimb       = fit_start[5]
period 		= fit_start[6]


time2 = time - mid_transit	;update time

z =a_rstar*sqrt( sin( ( (2*pi)/period)*time2)^2 + ( cos(incl) *cos( ((2*pi)/period) *time2))^2 )

exofast_occultquad,z,linlimb,quadlimb,rp,flux_model,F0	;FASTER!!
;occultquad,z,linlimb,quadlimb,rp,flux_model,F0

;z_new = exofast_getb(time2,i=incl,a=a_rstar,tperiastron=mid_transit,Period=period)

return,[flux_model]
end
