;This function was written for EXOPMOP.pro 
;It has limited capability without running the main program
;MODIFICATION HISTORY
;
; 2/13/13 --- Jake Turner (LPL) 2013 
; 		program created

function Useful_Values,time,res,best_model,flux_transit,size
;-----Calculate Cadence-----
cadence_diff = fltarr(size-1)
for i=0,size-2 do begin 
   cadence_diff[i] = time[i+1]-time[i] 
endfor 
   cadence = MEAN(cadence_diff) 

;-----Calculate Duration of Transit-----
w=where(best_model lt 1.0)
start=time[w[0]]
endtime=time[w[n_elements(w)-1]]
duration=endtime-start
error_dur = sqrt(2)*cadence

;----Calculate STDEV of OoT Baseline------
time_new = time

for i=0,size-1 do begin
  If best_model[i] ne 1.00 then begin
  time_new[i] = 0 
  endif 
endfor

baseline = fltarr(2,size)
base 	= fltarr(size)

baseline[0,*] = time_new 
baseline[1,*] = flux_transit  

for i=0, size-1 do begin			
   If baseline[0,i] gt 0 then begin
	 base[i] = baseline[1,i] 
   endif
endfor 
k = where(base gt 0)
ootstdev = STDEV(base[k])*1000


;----Output------
Value = fltarr(4)
Value[0] = ootstdev
Value[1] = duration
Value[2] = error_dur 
Value[3] = cadence

return,Value

end
