; This function uses Equation (9) in (Pont et al 2006, 373,231)
; to calculate the behavior of red and white noise in the 
; Time-Averaging red noise Technique
;
; INPUT: 
;        bin_size (HJD) 
;        input_parameters (white_noise, red_noise)
;OUPUT:  function_value ((white_noise^2)/bin_size + red_noise^2))
;
;MODIFICATION HISTORY
;
; 2/13/13 --- Jake Turner (LPL) 2013 
; 		program created

function beta_model,bin_size,fit_start

white_noise 	= fit_start[0] 	;white noise
red_noise	= fit_start[1] 	;red noise

;Equation 9 from Pont 2006
function_value = sqrt((white_noise^2)/bin_size + red_noise^2)

return,function_value
end
